package cz.mendelu.dnaAnalyser.analyse.cpg;


import cz.mendelu.dnaAnalyser.utils.repository.BaseRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.Optional;
import java.util.UUID;

public interface CpgRepository extends BaseRepository<Cpg, UUID> {

    @Query("select a from Cpg as a join a.owner o where o.id = ?#{principal.id}")
    Page<Cpg> findAll(Pageable pageable);

    @Query("select a from Cpg as a join a.owner o join a.tags t where t = :tag and o.id = ?#{principal.id}")
    Page<Cpg> findAll(Pageable pageable, @Param("tag") String tag);

    @Query("select a from Cpg as a join a.owner o where a.id = :id and o.id = ?#{principal.id}")
    Optional<Cpg> findById(@Param("id") UUID id);

    @Query("select distinct t from Cpg as s join s.owner o join s.tags t where o.id = ?#{principal.id}")
    Page<String> findAllTags(Pageable pageable);

}
