package cz.mendelu.dnaAnalyser.analyse.g4hunter;

import cz.mendelu.dnaAnalyser.sequence.Sequence;
import cz.mendelu.dnaAnalyser.user.User;
import cz.mendelu.dnaAnalyser.utils.analyse.model.Analyse;
import cz.mendelu.dnaAnalyser.utils.model.Identifiable;
import lombok.*;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;
import java.util.Set;
import java.util.UUID;

@Data
@Entity
@ToString(callSuper = true)
@NoArgsConstructor(access = AccessLevel.PROTECTED)
@EqualsAndHashCode(callSuper = true)
@Table(name = "g4hunter_analyses")
public class G4Hunter extends Analyse implements Identifiable {

    @Builder
    private G4Hunter(
            UUID id, Date created, Sequence sequence, User owner, Set<String> tags, Date finished, Long resultCount,
            Integer windowSize, Float threshold) {
        super((id != null) ? id : UUID.randomUUID(), created, sequence, owner, tags, finished, sequence.getName(), resultCount);
        this.windowSize = windowSize;
        this.threshold = threshold;
    }

    @Column(name = "window_size")
    private Integer windowSize;

    private Float threshold;

    private Float frequency;

}
