package cz.mendelu.dnaAnalyser.analyse.palindrome;

import cz.mendelu.dnaAnalyser.utils.repository.BaseRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.Optional;
import java.util.UUID;

@Repository
public interface PalindromeAnalyseRepository extends BaseRepository<PalindromeAnalyse, UUID> {

    @Query("select a from PalindromeAnalyse as a join a.owner o where o.id = ?#{principal.id}")
    Page<PalindromeAnalyse> findAll(Pageable pageable);

    @Query("select a from PalindromeAnalyse as a join a.owner o join a.tags t where t = :tag and o.id = ?#{principal.id}")
    Page<PalindromeAnalyse> findAll(Pageable pageable, @Param("tag") String tag);

    @Query("select a from PalindromeAnalyse as a join a.owner o where a.id = :id and o.id = ?#{principal.id}")
    Optional<PalindromeAnalyse> findById(@Param("id") UUID id);

    @Query("select t from PalindromeAnalyse as s join s.owner o join s.tags t where o.id = ?#{principal.id}")
    Page<String> findAllTags(Pageable pageable);
}
