package cz.mendelu.dnaAnalyser.analyse.rloopr;

import cz.mendelu.dnaAnalyser.sequence.Sequence;
import cz.mendelu.dnaAnalyser.user.User;
import cz.mendelu.dnaAnalyser.utils.analyse.model.Analyse;
import cz.mendelu.dnaAnalyser.utils.model.Identifiable;
import lombok.*;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;
import java.util.Set;
import java.util.UUID;

@Data
@Entity
@ToString(callSuper = true)
@NoArgsConstructor(access = AccessLevel.PROTECTED)
@EqualsAndHashCode(callSuper = true)
@Table(name = "rloopr_analyses")
public class Rloop extends Analyse implements Identifiable {

    @Builder
    private Rloop(UUID id, Date created, Sequence sequence, User owner, Set<String> tags, Date finished, Long resultCount, Short[] model) {
        super((id != null) ? id : UUID.randomUUID(), created, sequence, owner, tags, finished, sequence.getName(), resultCount);
        
         // 0 is m1, 1 is m2, 2 are both 
        if (model.length != 1) {
            this.model = 2; 
        }
        else {
            this.model = model[0];
        }
    }

    @Column(name = "model")
    private Short model;
}
