package cz.mendelu.dnaAnalyser.sequence;

import cz.mendelu.dnaAnalyser.utils.FirstRunImporter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.event.ApplicationReadyEvent;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.event.EventListener;
import org.springframework.core.io.Resource;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.core.io.support.ResourcePatternResolver;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.attribute.FileAttribute;
import java.util.Arrays;

@Slf4j
@Configuration
public class SequenceImporter {

    @Autowired
    FirstRunImporter importer;

    @Value("${sequence.dir}")
    private String destDir;

    @EventListener(ApplicationReadyEvent.class)
    public void copyDefaultSequencesToWorkingDirectory() {
        try {
            importer.importFiles("db/data/sequences/", destDir);
        } catch (Exception e) {
            log.warn("Create default sequences failed.", e);
        }

    }
}
