package cz.mendelu.dnaAnalyser.user

import cz.mendelu.dnaAnalyser.user.UserRepository
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.autoconfigure.orm.jpa.DataJpaTest
import org.springframework.boot.test.autoconfigure.orm.jpa.TestEntityManager
import org.springframework.test.context.ActiveProfiles
import spock.lang.Ignore
import spock.lang.Specification

@Ignore
@DataJpaTest
@ActiveProfiles("test")
class UserRepositoryTest extends Specification {

    @Autowired
    TestEntityManager entityManager

    @Autowired
    UserRepository userRepository


    def "FindByUsername: user exists in test db"() {
        when:
        def user = userRepository.findByUsername('user@mendelu.cz')

        then:
        user != null
        user.username == 'user@mendelu.cz'
    }

    def "FindByUsername: user no exists in test db"() {
        when:
        def user = userRepository.findByUsername('unknown@mendelu.cz')

        then:
        user == null
    }

    @Ignore
    def "FindCurrentUser"() {
        when:
        def user = userRepository.findCurrentUser()

        then:
        user != null
        user.username == 'user@mendelu.cz'
    }
}
